spapr: Simplify spapr_cpu_core_realize() and spapr_cpu_core_unrealize()
[qemu/ar7.git] / Makefile
blob4d1fa8bb3de370b1d5482394e4389406bdee3685
1 # Makefile for QEMU.
3 ifneq ($(words $(subst :, ,$(CURDIR))), 1)
4 $(error main directory cannot contain spaces nor colons)
5 endif
7 # Always point to the root of the build tree (needs GNU make).
8 BUILD_DIR=$(CURDIR)
10 # Before including a proper config-host.mak, assume we are in the source tree
11 SRC_PATH=.
13 # Don't use implicit rules or variables
14 # we have explicit rules for everything
15 MAKEFLAGS += -rR
17 SHELL = /usr/bin/env bash -o pipefail
19 # Usage: $(call quiet-command,command and args,"NAME","args to print")
20 # This will run "command and args", and either:
21 # if V=1 just print the whole command and args
22 # otherwise print the 'quiet' output in the format " NAME args to print"
23 # NAME should be a short name of the command, 7 letters or fewer.
24 # If called with only a single argument, will print nothing in quiet mode.
25 quiet-command-run = $(if $(V),,$(if $2,printf " %-7s %s\n" $2 $3 && ))$1
26 quiet-@ = $(if $(V),,@)
27 quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)
29 UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
30 help check-help print-% \
31 docker docker-% vm-help vm-test vm-build-%
33 all:
34 .PHONY: all clean distclean recurse-all dist msi FORCE
36 # Don't try to regenerate Makefile or configure
37 # We don't generate any of them
38 Makefile: ;
39 configure: ;
41 # All following code might depend on configuration variables
42 ifneq ($(wildcard config-host.mak),)
43 include config-host.mak
45 git-submodule-update:
46 .git-submodule-status: git-submodule-update config-host.mak
47 Makefile: .git-submodule-status
49 .PHONY: git-submodule-update
51 git_module_status := $(shell \
52 cd '$(SRC_PATH)' && \
53 GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
54 echo $$?; \
57 ifeq (1,$(git_module_status))
58 ifeq (no,$(GIT_UPDATE))
59 git-submodule-update:
60 $(call quiet-command, \
61 echo && \
62 echo "GIT submodule checkout is out of date. Please run" && \
63 echo " scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
64 echo "from the source directory checkout $(SRC_PATH)" && \
65 echo && \
66 exit 1)
67 else
68 git-submodule-update:
69 $(call quiet-command, \
70 (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
71 "GIT","$(GIT_SUBMODULES)")
72 endif
73 endif
75 # 0. ensure the build tree is okay
77 # Check that we're not trying to do an out-of-tree build from
78 # a tree that's been used for an in-tree build.
79 ifneq ($(realpath $(SRC_PATH)),$(realpath .))
80 ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
81 $(error This is an out of tree build but your source tree ($(SRC_PATH)) \
82 seems to have been used for an in-tree build. You can fix this by running \
83 "$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
84 endif
85 endif
87 # force a rerun of configure if config-host.mak is too old or corrupted
88 ifeq ($(MESON),)
89 .PHONY: config-host.mak
90 x := $(shell rm -rf meson-private meson-info meson-logs)
91 endif
92 ifeq ($(NINJA),)
93 .PHONY: config-host.mak
94 x := $(shell rm -rf meson-private meson-info meson-logs)
95 else
96 export NINJA
97 endif
98 ifeq ($(wildcard build.ninja),)
99 .PHONY: config-host.mak
100 x := $(shell rm -rf meson-private meson-info meson-logs)
101 endif
102 ifeq ($(origin prefix),file)
103 .PHONY: config-host.mak
104 x := $(shell rm -rf meson-private meson-info meson-logs)
105 endif
107 # 1. ensure config-host.mak is up-to-date
108 config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
109 @echo config-host.mak is out-of-date, running configure
110 @if test -f meson-private/coredata.dat; then \
111 ./config.status --skip-meson; \
112 else \
113 ./config.status && touch build.ninja.stamp; \
116 # 2. meson.stamp exists if meson has run at least once (so ninja reconfigure
117 # works), but otherwise never needs to be updated
118 meson-private/coredata.dat: meson.stamp
119 meson.stamp: config-host.mak
120 @touch meson.stamp
122 # 3. ensure generated build files are up-to-date
124 ifneq ($(NINJA),)
125 Makefile.ninja: build.ninja
126 $(quiet-@){ \
127 echo 'ninja-targets = \'; \
128 $(NINJA) -t targets all | sed 's/:.*//; $$!s/$$/ \\/'; \
129 echo 'build-files = \'; \
130 $(NINJA) -t query build.ninja | sed -n '1,/^ input:/d; /^ outputs:/q; s/$$/ \\/p'; \
131 } > $@.tmp && mv $@.tmp $@
132 -include Makefile.ninja
134 # A separate rule is needed for Makefile dependencies to avoid -n
135 build.ninja: build.ninja.stamp
136 build.ninja.stamp: meson.stamp $(build-files)
137 $(NINJA) $(if $V,-v,) build.ninja && touch $@
138 endif
140 ifneq ($(MESON),)
141 Makefile.mtest: build.ninja scripts/mtest2make.py
142 $(MESON) introspect --targets --tests --benchmarks | $(PYTHON) scripts/mtest2make.py > $@
143 -include Makefile.mtest
144 endif
146 # 4. Rules to bridge to other makefiles
148 ifneq ($(NINJA),)
149 NINJAFLAGS = $(if $V,-v,) \
150 $(filter-out -j, $(lastword -j1 $(filter -l% -j%, $(MAKEFLAGS)))) \
151 $(subst -k, -k0, $(filter -n -k,$(MAKEFLAGS)))
153 ninja-cmd-goals = $(or $(MAKECMDGOALS), all)
154 ninja-cmd-goals += $(foreach t, $(.tests), $(.test.deps.$t))
156 makefile-targets := build.ninja ctags TAGS cscope dist clean uninstall
157 # "ninja -t targets" also lists all prerequisites. If build system
158 # files are marked as PHONY, however, Make will always try to execute
159 # "ninja build.ninja".
160 ninja-targets := $(filter-out $(build-files) $(makefile-targets), $(ninja-targets))
161 .PHONY: $(ninja-targets) run-ninja
162 $(ninja-targets): run-ninja
164 # Use "| cat" to give Ninja a more "make-y" output. Use "+" to bypass the
165 # --output-sync line.
166 run-ninja: config-host.mak
167 ifneq ($(filter $(ninja-targets), $(ninja-cmd-goals)),)
168 +@$(NINJA) $(NINJAFLAGS) $(sort $(filter $(ninja-targets), $(ninja-cmd-goals))) | cat
169 endif
170 endif
172 # Force configure to re-run if the API symbols are updated
173 ifeq ($(CONFIG_PLUGIN),y)
174 config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols
176 .PHONY: plugins
177 plugins:
178 $(call quiet-command,\
179 $(MAKE) $(SUBDIR_MAKEFLAGS) -C contrib/plugins V="$(V)", \
180 "BUILD", "example plugins")
181 endif # $(CONFIG_PLUGIN)
183 else # config-host.mak does not exist
184 config-host.mak:
185 ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
186 @echo "Please call configure before running make!"
187 @exit 1
188 endif
189 endif # config-host.mak does not exist
191 SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory --quiet)
193 include $(SRC_PATH)/tests/Makefile.include
195 all: recurse-all
197 ROM_DIRS = $(addprefix pc-bios/, $(ROMS))
198 ROM_DIRS_RULES=$(foreach t, all clean, $(addsuffix /$(t), $(ROM_DIRS)))
199 # Only keep -O and -g cflags
200 .PHONY: $(ROM_DIRS_RULES)
201 $(ROM_DIRS_RULES):
202 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $(dir $@) V="$(V)" TARGET_DIR="$(dir $@)" $(notdir $@),)
204 .PHONY: recurse-all recurse-clean
205 recurse-all: $(addsuffix /all, $(ROM_DIRS))
206 recurse-clean: $(addsuffix /clean, $(ROM_DIRS))
208 ######################################################################
210 clean: recurse-clean
211 -@test -f build.ninja && $(quiet-@)$(NINJA) $(NINJAFLAGS) -t clean || :
212 -@test -f build.ninja && $(NINJA) $(NINJAFLAGS) clean-ctlist || :
213 # avoid old build problems by removing potentially incorrect old files
214 rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
215 find . \( -name '*.so' -o -name '*.dll' -o -name '*.[oda]' \) -type f \
216 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-aarch64.a \
217 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-arm.a \
218 -exec rm {} +
219 rm -f TAGS cscope.* *.pod *~ */*~
220 rm -f fsdev/*.pod scsi/*.pod
222 VERSION = $(shell cat $(SRC_PATH)/VERSION)
224 dist: qemu-$(VERSION).tar.bz2
226 qemu-%.tar.bz2:
227 $(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"
229 distclean: clean
230 -@test -f build.ninja && $(quiet-@)$(NINJA) $(NINJAFLAGS) -t clean -g || :
231 rm -f config-host.mak config-host.h*
232 rm -f tests/tcg/config-*.mak
233 rm -f config-all-disas.mak config.status
234 rm -f tests/qemu-iotests/common.env
235 rm -f roms/seabios/config.mak roms/vgabios/config.mak
236 rm -f qemu-plugins-ld.symbols qemu-plugins-ld64.symbols
237 rm -f *-config-target.h *-config-devices.mak *-config-devices.h
238 rm -rf meson-private meson-logs meson-info compile_commands.json
239 rm -f Makefile.ninja Makefile.mtest build.ninja.stamp meson.stamp
240 rm -f config.log
241 rm -f linux-headers/asm
242 rm -Rf .sdk
244 find-src-path = find "$(SRC_PATH)/" -path "$(SRC_PATH)/meson" -prune -o -name "*.[chsS]"
246 .PHONY: ctags
247 ctags:
248 rm -f "$(SRC_PATH)/"tags
249 $(find-src-path) -exec ctags -f "$(SRC_PATH)/"tags --append {} +
251 .PHONY: TAGS
252 TAGS:
253 rm -f "$(SRC_PATH)/"TAGS
254 $(find-src-path) -exec etags -f "$(SRC_PATH)/"TAGS --append {} +
256 .PHONY: cscope
257 cscope:
258 rm -f "$(SRC_PATH)"/cscope.*
259 $(find-src-path) -print | sed -e 's,^\./,,' > "$(SRC_PATH)/cscope.files"
260 cscope -b -i"$(SRC_PATH)/cscope.files" -f"$(SRC_PATH)"/cscope.out
262 # Needed by "meson install"
263 export DESTDIR
265 include $(SRC_PATH)/tests/docker/Makefile.include
266 include $(SRC_PATH)/tests/vm/Makefile.include
268 print-help-run = printf " %-30s - %s\\n" "$1" "$2"
269 print-help = $(quiet-@)$(call print-help-run,$1,$2)
271 .PHONY: help
272 help:
273 @echo 'Generic targets:'
274 $(call print-help,all,Build all)
275 $(call print-help,dir/file.o,Build specified target only)
276 $(call print-help,install,Install QEMU, documentation and tools)
277 $(call print-help,ctags/TAGS,Generate tags file for editors)
278 $(call print-help,cscope,Generate cscope index)
279 $(call print-help,sparse,Run sparse on the QEMU source)
280 @echo ''
281 ifeq ($(CONFIG_PLUGIN),y)
282 @echo 'Plugin targets:'
283 $(call print-help,plugins,Build the example TCG plugins)
284 @echo ''
285 endif
286 @echo 'Cleaning targets:'
287 $(call print-help,clean,Remove most generated files but keep the config)
288 $(call print-help,distclean,Remove all generated files)
289 $(call print-help,dist,Build a distributable tarball)
290 @echo ''
291 @echo 'Test targets:'
292 $(call print-help,check,Run all tests (check-help for details))
293 $(call print-help,bench,Run all benchmarks)
294 $(call print-help,docker,Help about targets running tests inside containers)
295 $(call print-help,vm-help,Help about targets running tests inside VM)
296 @echo ''
297 @echo 'Documentation targets:'
298 $(call print-help,html man,Build documentation in specified format)
299 @echo ''
300 ifdef CONFIG_WIN32
301 @echo 'Windows targets:'
302 $(call print-help,installer,Build NSIS-based installer for QEMU)
303 ifdef CONFIG_QGA_MSI
304 $(call print-help,msi,Build MSI-based installer for qemu-ga)
305 endif
306 @echo ''
307 endif
308 $(call print-help,$(MAKE) [targets],(quiet build, default))
309 $(call print-help,$(MAKE) V=1 [targets],(verbose build))
311 # will delete the target of a rule if commands exit with a nonzero exit status
312 .DELETE_ON_ERROR:
314 print-%:
315 @echo '$*=$($*)'